Loading...
Searching...
No Matches
IsoSpec::IsoLayeredGeneratorTemplate< MarginalType > Class Template Reference
Inheritance diagram for IsoSpec::IsoLayeredGeneratorTemplate< MarginalType >:

## Public Member Functions

| IsoLayeredGeneratorTemplate (const IsoLayeredGeneratorTemplate &other)=delete
IsoLayeredGeneratorTemplate & | operator= (const IsoLayeredGeneratorTemplate &other)=delete
void | get_conf_signature (int *space) const override final
| Write the signature of configuration into target memory location. It must be large enough to accomodate it.
double | get_currentLThreshold () const
| IsoLayeredGeneratorTemplate (Iso &&iso, int _tabSize=1000, int _hashSize=1000, bool reorder_marginals=true, double t_prob_hint=0.99)
ISOSPEC_FORCE_INLINE bool | advanceToNextConfiguration () override final
| Advance to the next, not yet visited, most probable isotopologue.
ISOSPEC_FORCE_INLINE bool | advanceToNextConfigurationWithinLayer ()
ISOSPEC_FORCE_INLINE double | lprob () const override final
| Get the log-probability of the current isotopologue.
ISOSPEC_FORCE_INLINE double | mass () const override final
| Get the mass of the current isotopologue.
ISOSPEC_FORCE_INLINE double | prob () const override final
| Get the probability of the current isotopologue.
void | terminate_search ()
| Block the subsequent search of isotopologues.
ISOSPEC_FORCE_INLINE void | recalc (int idx)
| Recalculate the current partial log-probabilities, masses, and probabilities.
bool | nextLayer (double offset)
void | get_conf_by_indexes (int *space) const
Public Member Functions inherited from IsoSpec::IsoGenerator
| IsoGenerator (Iso &&iso, bool alloc_partials=true)
| Move constructor.
virtual | ~IsoGenerator ()
| Destructor.
Public Member Functions inherited from IsoSpec::Iso
| Iso (int _dimNumber, const int *_isotopeNumbers, const int *_atomCounts, const double *_isotopeMasses, const double *_isotopeProbabilities)
| General constructror.
| Iso (int _dimNumber, const int *_isotopeNumbers, const int *_atomCounts, const double *const *_isotopeMasses, const double *const *_isotopeProbabilities)
| Iso (const char *formula, bool use_nominal_masses=false)
| Constructor from the formula object.
| Iso (const std::string &formula, bool use_nominal_masses=false)
| Constructor from C++ std::string chemical formula.
| Iso (Iso &&other)
| The move constructor.
Iso & | operator= (const Iso &other)=delete
| Iso (const Iso &other, bool fullcopy)
| The copy constructor.
virtual | ~Iso ()
| Destructor.
double | getLightestPeakMass () const
| Get the mass of the lightest peak in the isotopic distribution.
double | getHeaviestPeakMass () const
| Get the mass of the heaviest peak in the isotopic distribution.
double | getMonoisotopicPeakMass () const
double | getModeLProb () const
| Get the log-probability of the mode-configuration (if there are many modes, they share this value).
double | getUnlikeliestPeakLProb () const
| Get the logprobability of the least probable subisotopologue.
double | getModeMass () const
| Get the mass of the mode-configuration (if there are many modes, it is undefined which one will be selected).
double | getTheoreticalAverageMass () const
| Get the theoretical average mass of the molecule.
double | variance () const
| Get the theoretical variance of the distribution.
double | stddev () const
| Get the standard deviation of the theoretical distribution.
int | getDimNumber () const
| Get the number of elements in the chemical formula of the molecule.
int | getAllDim () const
| Get the total number of isotopes of elements present in a chemical formula.
void | addElement (int atomCount, int noIsotopes, const double *isotopeMasses, const double *isotopeProbabilities)
| Add an element to the molecule. Note: this method can only be used BEFORE Iso is used to construct an IsoGenerator instance.
void | saveMarginalLogSizeEstimates (double *priorities, double target_total_prob) const
| Save estimates of logarithms of target sizes of marginals using Gaussian approximation into argument array. Array priorities must have length equal to dimNumber.

## Additional Inherited Members

Static Public Member Functions inherited from IsoSpec::Iso
static Iso | FromFASTA (const char *fasta, bool use_nominal_masses=false, bool add_water=true)
| Constructor (named) from aminoacid FASTA sequence as C string.
static Iso | FromFASTA (const std::string &fasta, bool use_nominal_masses=false, bool add_water=true)
| Constructor (named) from aminoacid FASTA sequence as C++ std::string. See above for details.
Public Attributes inherited from IsoSpec::IsoGenerator
const double | mode_lprob
Protected Member Functions inherited from IsoSpec::Iso
bool | doMarginalsNeedSorting () const
Protected Attributes inherited from IsoSpec::IsoGenerator
double * | partialLProbs
double * | partialMasses
double * | partialProbs
Protected Attributes inherited from IsoSpec::Iso
int | dimNumber
int * | isotopeNumbers
int * | atomCounts
unsigned int | confSize
int | allDim
Marginal ** | marginals

## Detailed Description

template<typename MarginalType>
class IsoSpec::IsoLayeredGeneratorTemplate< MarginalType >

Definition at line 460 of file isoSpec++.h.

## Constructor & Destructor Documentation

## IsoLayeredGeneratorTemplate()

template<typename MarginalType>

IsoSpec::IsoLayeredGeneratorTemplate< MarginalType >::IsoLayeredGeneratorTemplate | ( | Iso && | iso,
|  | int | _tabSize = 1000,
|  | int | _hashSize = 1000,
|  | bool | reorder_marginals = true,
|  | double | t_prob_hint = 0.99 )

Definition at line 654 of file isoSpec++.cpp.

## ~IsoLayeredGeneratorTemplate()

template<typename MarginalType>

IsoSpec::IsoLayeredGeneratorTemplate< MarginalType >::~IsoLayeredGeneratorTemplate | ( |  | ) |

Definition at line 799 of file isoSpec++.cpp.

## Member Function Documentation

## advanceToNextConfiguration()

template<typename MarginalType>

ISOSPEC_FORCE_INLINE bool IsoSpec::IsoLayeredGeneratorTemplate< MarginalType >::advanceToNextConfiguration | ( |  | ) |

inline final override virtual

Advance to the next, not yet visited, most probable isotopologue.

Returns
  Return false if it is not possible to advance.

Implements IsoSpec::IsoGenerator.

Definition at line 510 of file isoSpec++.h.

## advanceToNextConfigurationWithinLayer()

template<typename MarginalType>

ISOSPEC_FORCE_INLINE bool IsoSpec::IsoLayeredGeneratorTemplate< MarginalType >::advanceToNextConfigurationWithinLayer | ( |  | ) |

inline

Definition at line 520 of file isoSpec++.h.

## get_conf_by_indexes()

template<typename MarginalType>

void IsoSpec::IsoLayeredGeneratorTemplate< MarginalType >::get_conf_by_indexes | ( | int * | space | ) | const

inline

Definition at line 557 of file isoSpec++.h.

## get_conf_signature()

template<typename MarginalType>

void IsoSpec::IsoLayeredGeneratorTemplate< MarginalType >::get_conf_signature | ( | int * | space | ) | const

inline final override virtual

Write the signature of configuration into target memory location. It must be large enough to accomodate it.

Implements IsoSpec::IsoGenerator.

Definition at line 482 of file isoSpec++.h.

## get_currentLThreshold()

template<typename MarginalType>

double IsoSpec::IsoLayeredGeneratorTemplate< MarginalType >::get_currentLThreshold | ( |  | ) | const

inline

Definition at line 504 of file isoSpec++.h.

## lprob()

template<typename MarginalType>

ISOSPEC_FORCE_INLINE double IsoSpec::IsoLayeredGeneratorTemplate< MarginalType >::lprob | ( |  | ) | const

inline final override virtual

Get the log-probability of the current isotopologue.

Returns
  The log-probability of the current isotopologue.

Reimplemented from IsoSpec::IsoGenerator.

Definition at line 532 of file isoSpec++.h.

## mass()

template<typename MarginalType>

ISOSPEC_FORCE_INLINE double IsoSpec::IsoLayeredGeneratorTemplate< MarginalType >::mass | ( |  | ) | const

inline final override virtual

Get the mass of the current isotopologue.

Returns
  The mass of the current isotopologue.

Reimplemented from IsoSpec::IsoGenerator.

Definition at line 533 of file isoSpec++.h.

## nextLayer()

template<typename MarginalType>

bool IsoSpec::IsoLayeredGeneratorTemplate< MarginalType >::nextLayer | ( | double | offset | ) |

Definition at line 722 of file isoSpec++.cpp.

## prob()

template<typename MarginalType>

ISOSPEC_FORCE_INLINE double IsoSpec::IsoLayeredGeneratorTemplate< MarginalType >::prob | ( |  | ) | const

inline final override virtual

Get the probability of the current isotopologue.

Returns
  The probability of the current isotopologue.

Reimplemented from IsoSpec::IsoGenerator.

Definition at line 534 of file isoSpec++.h.

## recalc()

template<typename MarginalType>

ISOSPEC_FORCE_INLINE void IsoSpec::IsoLayeredGeneratorTemplate< MarginalType >::recalc | ( | int | idx | ) |

inline

Recalculate the current partial log-probabilities, masses, and probabilities.

Definition at line 541 of file isoSpec++.h.

## terminate_search()

template<typename MarginalType>

void IsoSpec::IsoLayeredGeneratorTemplate< MarginalType >::terminate_search | ( |  | ) |

Block the subsequent search of isotopologues.

Definition at line 787 of file isoSpec++.cpp.

The documentation for this class was generated from the following files:

- /build/isospec-8QB56o/isospec-2.3.2/src/IsoSpec++/isoSpec++.h
- /build/isospec-8QB56o/isospec-2.3.2/src/IsoSpec++/isoSpec++.cpp